## mingw-w64 7.0.0

=== debian/changelog ===
mingw-w64 (7.0.0-2) unstable; urgency=medium

  * Avoid erroring out in the build on CPUs which aren’t used on Windows;
    instead, require that the target be specified when widl is used on
    such systems. This allows building the package on architectures other
    than x86, ARM and PowerPC.

 -- Stephen Kitt <skitt@debian.org>  Fri, 15 Nov 2019 22:53:07 +0100

mingw-w64 (7.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Use dh clean to clean.
  * Standards-Version 4.4.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 11 Nov 2019 23:13:04 +0100
