## mingw-w64 8.0.0

=== debian/changelog ===
mingw-w64 (8.0.0-1) unstable; urgency=medium

  * New upstream release, merging comutil-checkerror.patch and
    genlib-lm.patch.

 -- Stephen Kitt <skitt@debian.org>  Fri, 18 Sep 2020 18:18:53 +0200

mingw-w64 (7.0.0-4) unstable; urgency=medium

  * Fix the broken + handling in genpeimg.

 -- Stephen Kitt <skitt@debian.org>  Thu, 30 Apr 2020 21:38:34 +0200

mingw-w64 (7.0.0-3) unstable; urgency=medium

  * Ship our own pkg-config-crosswrapper, and use that for
    i686-w64-mingw32-pkg-config and x86-64-w64-mingw32-pkg-config.
    Closes: #930492.
  * Handle multiple files in genpeimg. Closes: #953213.
  * Standards-Version 4.5.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 30 Apr 2020 21:15:36 +0200
