=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                automake (>= 1:1.14)
 Build-Depends-Indep: gcc-mingw-w64-i686 | gcc-mingw-w64-bootstrap (>= 4.6.0),
                      gcc-mingw-w64-x86-64 | gcc-mingw-w64-bootstrap (>= 4.6.0)
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/mingw-w64-team/mingw-w64
 Vcs-Git: https://salsa.debian.org/mingw-w64-team/mingw-w64.git
 Homepage: http://mingw-w64.sf.net
