## mingw-w64 11.0.1

=== debian/changelog ===
mingw-w64 (11.0.1-3build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 13:10:39 +0200

mingw-w64 (11.0.1-3) unstable; urgency=medium

  * Add support for loongarch; thanks to JiaLing Zhang for the patch!
    Closes: #1051916.

 -- Stephen Kitt <skitt@debian.org>  Thu, 14 Sep 2023 13:53:03 +0200

mingw-w64 (11.0.1-2) unstable; urgency=medium

  [ John Scott ]
  * Add a DEP-8 test checking that MinGW can make functioning LDAP
    applications with the Windows LDAP API

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 Aug 2023 19:01:04 +0200

mingw-w64 (11.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove all generated files when cleaning. Closes: #1048994.

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 Aug 2023 08:48:44 +0200

mingw-w64 (11.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.2, no change required.
  * Ignore no-code-sections Lintian errors, Lintian doesn’t know about
    non-ELF libraries.

 -- Stephen Kitt <skitt@debian.org>  Sun, 18 Jun 2023 16:00:17 +0200
