=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: mingw-w64
-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
 Build-Depends-Indep: gcc-mingw-w64-i686 | gcc-mingw-w64-bootstrap (>= 4.6.0),
                      gcc-mingw-w64-x86-64 | gcc-mingw-w64-bootstrap (>= 4.6.0)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/mingw-w64-team/mingw-w64
 Vcs-Git: https://salsa.debian.org/mingw-w64-team/mingw-w64.git
 Homepage: http://mingw-w64.sf.net
