## mingw-w64 12.0.0

=== debian/changelog ===
mingw-w64 (12.0.0-5) unstable; urgency=medium

  * Sourceful upload, buildable with GCC 13.
  * Add widl man page for UCRT.

 -- Stephen Kitt <skitt@debian.org>  Mon, 20 Jan 2025 17:36:04 +0100

mingw-w64 (12.0.0-4) unstable; urgency=medium

  * Clean more generated files to allow building several times in a row.
  * Bootstrap UCRT.

 -- Stephen Kitt <skitt@debian.org>  Sat, 18 Jan 2025 17:21:45 +0100

mingw-w64 (12.0.0-3) unstable; urgency=medium

  * Remove most of widl’s copied winbase.h and winnt.h; those
    declarations aren’t used in widl and regularly cause build issues.
    Closes: #1075275.

 -- Stephen Kitt <skitt@debian.org>  Mon, 29 Jul 2024 12:30:25 +0200

mingw-w64 (12.0.0-2) unstable; urgency=medium

  * In widl, ignore NtCurrentTeb entirely to allow building on all
    architectures (widl doesn’t use it).

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Jun 2024 12:47:17 +0200

mingw-w64 (12.0.0-1) unstable; urgency=medium

  * New upstream release, dropping genlib.
  * Depend on pkgconf instead of pkg-config.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Jun 2024 08:55:17 +0200

mingw-w64 (11.0.1-4) unstable; urgency=medium

  * Disable 64-bit time_t flags in dpkg-buildflags when cross-compiling.
    Closes: #1069528.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 12 May 2024 22:40:54 +0200
